InvertibleRSAFunction Class Reference

RSA trapdoor function using the private key. More...

`#include <rsa.h>`

Inheritance diagram for InvertibleRSAFunction:

## Public Member Functions

void | Initialize (RandomNumberGenerator &rng, unsigned int modulusBits, const Integer &e=17)
| Create a RSA private key.
void | Initialize (const Integer &n, const Integer &e, const Integer &d, const Integer &p, const Integer &q, const Integer &dp, const Integer &dq, const Integer &u)
| Initialize a RSA private key.
void | Initialize (const Integer &n, const Integer &e, const Integer &d)
| Initialize a RSA private key.
void | BERDecode (BufferedTransformation &bt)
| Decode this object from a BufferedTransformation.
void | DEREncode (BufferedTransformation &bt) const
| Encode this object into a BufferedTransformation.
void | Load (BufferedTransformation &bt)
| BER decode ASN.1 object.
void | Save (BufferedTransformation &bt) const
| DER encode ASN.1 object.
OID | GetAlgorithmID () const
| Retrieves the OID of the algorithm.
void | BERDecodePrivateKey (BufferedTransformation &bt, bool parametersPresent, size_t size)
| Decode privateKey part of privateKeyInfo.
void | DEREncodePrivateKey (BufferedTransformation &bt) const
| Encode privateKey part of privateKeyInfo.
Integer | CalculateInverse (RandomNumberGenerator &rng, const Integer &x) const
| Calculates the inverse of an element.
bool | Validate (RandomNumberGenerator &rng, unsigned int level) const
| Check this object for errors.
void | GenerateRandom (RandomNumberGenerator &rng, const NameValuePairs &alg)
| Generate a random key or crypto parameters.
bool | GetVoidValue (const char *name, const std::type_info &valueType, void *pValue) const
| Get a named value.
void | AssignFrom (const NameValuePairs &source)
| Assign values to this object.
const Integer & | GetPrime1 () const
const Integer & | GetPrime2 () const
const Integer & | GetPrivateExponent () const
const Integer & | GetModPrime1PrivateExponent () const
const Integer & | GetModPrime2PrivateExponent () const
const Integer & | GetMultiplicativeInverseOfPrime2ModPrime1 () const
void | SetPrime1 (const Integer &p)
void | SetPrime2 (const Integer &q)
void | SetPrivateExponent (const Integer &d)
void | SetModPrime1PrivateExponent (const Integer &dp)
void | SetModPrime2PrivateExponent (const Integer &dq)
void | SetMultiplicativeInverseOfPrime2ModPrime1 (const Integer &u)
Public Member Functions inherited from RSAFunction
void | Initialize (const Integer &n, const Integer &e)
| Initialize a RSA public key.
OID | GetAlgorithmID () const
| Retrieves the OID of the algorithm.
void | BERDecodePublicKey (BufferedTransformation &bt, bool parametersPresent, size_t size)
| Decode subjectPublicKey part of subjectPublicKeyInfo.
void | DEREncodePublicKey (BufferedTransformation &bt) const
| Encode subjectPublicKey part of subjectPublicKeyInfo.
bool | Validate (RandomNumberGenerator &rng, unsigned int level) const
| Check this object for errors.
bool | GetVoidValue (const char *name, const std::type_info &valueType, void *pValue) const
| Get a named value.
void | AssignFrom (const NameValuePairs &source)
| Assign values to this object.
Integer | ApplyFunction (const Integer &x) const
| Applies the trapdoor.
Integer | PreimageBound () const
| Returns the maximum size of a message before the trapdoor function is applied.
Integer | ImageBound () const
| Returns the maximum size of a representation after the trapdoor function is applied.
const Integer & | GetModulus () const
const Integer & | GetPublicExponent () const
void | SetModulus (const Integer &n)
void | SetPublicExponent (const Integer &e)
Public Member Functions inherited from TrapdoorFunction
Integer | ApplyRandomizedFunction (RandomNumberGenerator &rng, const Integer &x) const
| Applies the trapdoor function.
bool | IsRandomized () const
| Determines if the encryption algorithm is randomized.
Public Member Functions inherited from TrapdoorFunctionBounds
virtual Integer | MaxPreimage () const
| Returns the maximum size of a message before the trapdoor function is applied bound to a public key.
virtual Integer | MaxImage () const
| Returns the maximum size of a representation after the trapdoor function is applied bound to a public key.
Public Member Functions inherited from X509PublicKey
void | BERDecode (BufferedTransformation &bt)
| Decode this object from a BufferedTransformation.
void | DEREncode (BufferedTransformation &bt) const
| Encode this object into a BufferedTransformation.
virtual bool | BERDecodeAlgorithmParameters (BufferedTransformation &bt)
| Decode algorithm parameters.
virtual bool | DEREncodeAlgorithmParameters (BufferedTransformation &bt) const
| Encode algorithm parameters.
Public Member Functions inherited from ASN1Object
virtual void | BEREncode (BufferedTransformation &bt) const
| Encode this object into a BufferedTransformation.
Public Member Functions inherited from CryptoMaterial
virtual void | ThrowIfInvalid (RandomNumberGenerator &rng, unsigned int level) const
| Check this object for errors.
virtual bool | SupportsPrecomputation () const
| Determines whether the object supports precomputation.
virtual void | Precompute (unsigned int precomputationStorage)
| Perform precomputation.
virtual void | LoadPrecomputation (BufferedTransformation &storedPrecomputation)
| Retrieve previously saved precomputation.
virtual void | SavePrecomputation (BufferedTransformation &storedPrecomputation) const
| Save precomputation for later use.
void | DoQuickSanityCheck () const
| Perform a quick sanity check.
Public Member Functions inherited from NameValuePairs
template<class T>
bool | GetThisObject (T &object) const
| Get a copy of this object or subobject.
template<class T>
bool | GetThisPointer (T *&ptr) const
| Get a pointer to this object.
template<class T>
bool | GetValue (const char *name, T &value) const
| Get a named value.
template<class T>
T | GetValueWithDefault (const char *name, T defaultValue) const
| Get a named value.
CRYPTOPP_DLL std::string | GetValueNames () const
| Get a list of value names that can be retrieved.
CRYPTOPP_DLL bool | GetIntValue (const char *name, int &value) const
| Get a named value with type int.
CRYPTOPP_DLL int | GetIntValueWithDefault (const char *name, int defaultValue) const
| Get a named value with type int, with default.
CRYPTOPP_DLL bool | GetWord64Value (const char *name, word64 &value) const
| Get a named value with type word64.
CRYPTOPP_DLL word64 | GetWord64ValueWithDefault (const char *name, word64 defaultValue) const
| Get a named value with type word64, with default.
template<class T>
void | GetRequiredParameter (const char *className, const char *name, T &value) const
| Retrieves a required name/value pair.
CRYPTOPP_DLL void | GetRequiredIntParameter (const char *className, const char *name, int &value) const
| Retrieves a required name/value pair.
Public Member Functions inherited from TrapdoorFunctionInverse
Integer | CalculateRandomizedInverse (RandomNumberGenerator &rng, const Integer &x) const
| Applies the inverse of the trapdoor function.
bool | IsRandomized () const
| Determines if the decryption algorithm is randomized.
Public Member Functions inherited from PKCS8PrivateKey
void | BERDecode (BufferedTransformation &bt)
| Decode this object from a BufferedTransformation.
void | DEREncode (BufferedTransformation &bt) const
| Encode this object into a BufferedTransformation.
virtual bool | BERDecodeAlgorithmParameters (BufferedTransformation &bt)
| Decode optional parameters.
virtual bool | DEREncodeAlgorithmParameters (BufferedTransformation &bt) const
| Encode optional parameters.
virtual void | BERDecodeOptionalAttributes (BufferedTransformation &bt)
| Decode optional attributes.
virtual void | DEREncodeOptionalAttributes (BufferedTransformation &bt) const
| Encode optional attributes.
Public Member Functions inherited from GeneratableCryptoMaterial
void | GenerateRandomWithKeySize (RandomNumberGenerator &rng, unsigned int keySize)
| Generate a random key or crypto parameters.

## Additional Inherited Members

Static Public Member Functions inherited from NameValuePairs
static CRYPTOPP_DLL void | ThrowIfTypeMismatch (const char *name, const std::type_info &stored, const std::type_info &retrieving)
| Ensures an expected name and type is present.

## Detailed Description

RSA trapdoor function using the private key.

Since
  Crypto++ 1.0

Definition at line 62 of file rsa.h.

## Member Function Documentation

## Initialize() [1/3]

void InvertibleRSAFunction::Initialize | ( | RandomNumberGenerator & | rng,
|  | unsigned int | modulusBits,
|  | const Integer & | e = 17 )

Create a RSA private key.

Parameters

  rng | a RandomNumberGenerator derived class
  modulusBits | the size of the modulus, in bits
  e | the desired public exponent

Initialize() creates a new keypair using a public exponent of 17.

This function overload of Initialize() creates a new private key because it takes a RandomNumberGenerator() as a parameter. If you have an existing keypair, then use one of the other Initialize() overloads.

## Initialize() [2/3]

void InvertibleRSAFunction::Initialize | ( | const Integer & | n,
|  | const Integer & | e,
|  | const Integer & | d,
|  | const Integer & | p,
|  | const Integer & | q,
|  | const Integer & | dp,
|  | const Integer & | dq,
|  | const Integer & | u )

inline

Initialize a RSA private key.

Parameters

  n | modulus
  e | public exponent
  d | private exponent
  p | first prime factor
  q | second prime factor
  dp | d mod p
  dq | d mod q
  u | q-1 mod p

This Initialize() function overload initializes a private key from existing parameters.

Definition at line 87 of file rsa.h.

## Initialize() [3/3]

void InvertibleRSAFunction::Initialize | ( | const Integer & | n,
|  | const Integer & | e,
|  | const Integer & | d )

Initialize a RSA private key.

Parameters

  n | modulus
  e | public exponent
  d | private exponent

This Initialize() function overload initializes a private key from existing parameters. Initialize() will factor n using d and populate {p,q,dp,dq,u}.

## BERDecode()

void InvertibleRSAFunction::BERDecode | ( | BufferedTransformation & | bt | ) |

inline virtual

Decode this object from a BufferedTransformation.

Parameters

  bt | BufferedTransformation object

Uses Basic Encoding Rules (BER)

Implements ASN1Object.

Definition at line 99 of file rsa.h.

## DEREncode()

void InvertibleRSAFunction::DEREncode | ( | BufferedTransformation & | bt | ) | const

inline virtual

Encode this object into a BufferedTransformation.

Parameters

  bt | BufferedTransformation object

Uses Distinguished Encoding Rules (DER)

Implements ASN1Object.

Definition at line 101 of file rsa.h.

## Load()

void InvertibleRSAFunction::Load | ( | BufferedTransformation & | bt | ) |

inline virtual

BER decode ASN.1 object.

Parameters

  bt | BufferedTransformation object

Reimplemented from ASN1CryptoMaterial< PublicKey >.

Definition at line 103 of file rsa.h.

## Save()

void InvertibleRSAFunction::Save | ( | BufferedTransformation & | bt | ) | const

inline virtual

DER encode ASN.1 object.

Parameters

  bt | BufferedTransformation object

Save() will write the OID associated with algorithm or scheme. In the case of public and private keys, this function writes the subjectPublicKeyInfo and privateKeyInfo parts.

Reimplemented from ASN1CryptoMaterial< PublicKey >.

Definition at line 105 of file rsa.h.

## GetAlgorithmID()

OID InvertibleRSAFunction::GetAlgorithmID | ( |  | ) | const

inline virtual

Retrieves the OID of the algorithm.

Returns
  OID of the algorithm

Implements X509PublicKey.

Definition at line 107 of file rsa.h.

## BERDecodePrivateKey()

void InvertibleRSAFunction::BERDecodePrivateKey | ( | BufferedTransformation & | bt,
|  | bool | parametersPresent,
|  | size_t | size )

virtual

Decode privateKey part of privateKeyInfo.

Parameters

  bt | BufferedTransformation object
  parametersPresent | flag indicating if algorithm parameters are present
  size | number of octets to read for the parameters, in bytes

BERDecodePrivateKey() the decodes privateKey part of privateKeyInfo, without the OCTET STRING header.

When parametersPresent = true then BERDecodePrivateKey() calls BERDecodeAlgorithmParameters() to parse algorithm parameters.

See also
  BERDecodeAlgorithmParameters

Implements PKCS8PrivateKey.

## DEREncodePrivateKey()

void InvertibleRSAFunction::DEREncodePrivateKey | ( | BufferedTransformation & | bt | ) | const

virtual

Encode privateKey part of privateKeyInfo.

Parameters

  bt | BufferedTransformation object

DEREncodePrivateKey() encodes the privateKey part of privateKeyInfo, without the OCTET STRING header.

See also
  DEREncodeAlgorithmParameters

Implements PKCS8PrivateKey.

## CalculateInverse()

Integer InvertibleRSAFunction::CalculateInverse | ( | RandomNumberGenerator & | rng,
|  | const Integer & | x ) const

virtual

Calculates the inverse of an element.

Parameters

  rng | a RandomNumberGenerator derived class
  x | the element

Returns
  the inverse of the element in the group

Implements TrapdoorFunctionInverse.

Reimplemented in InvertibleRSAFunction_ISO.

## Validate()

bool InvertibleRSAFunction::Validate | ( | RandomNumberGenerator & | rng,
|  | unsigned int | level ) const

virtual

Check this object for errors.

Parameters

  rng | a RandomNumberGenerator for objects which use randomized testing
  level | the level of thoroughness

Returns
  true if the tests succeed, false otherwise

There are four levels of thoroughness:

- 0 - using this object won't cause a crash or exception
- 1 - this object will probably function, and encrypt, sign, other operations correctly
- 2 - ensure this object will function correctly, and perform reasonable security checks
- 3 - perform reasonable security checks, and do checks that may take a long time

Level 0 does not require a RandomNumberGenerator. A NullRNG() can be used for level 0. Level 1 may not check for weak keys and such. Levels 2 and 3 are recommended.

See also
  ThrowIfInvalid()

Implements CryptoMaterial.

## GenerateRandom()

void InvertibleRSAFunction::GenerateRandom | ( | RandomNumberGenerator & | rng,
|  | const NameValuePairs & | params )

virtual

Generate a random key or crypto parameters.

Parameters

  rng | a RandomNumberGenerator to produce keying material
  params | additional initialization parameters

Exceptions

  KeyingErr | if a key can't be generated or algorithm parameters are invalid

If a derived class does not override GenerateRandom(), then the base class throws NotImplemented.

Reimplemented from GeneratableCryptoMaterial.

## GetVoidValue()

bool InvertibleRSAFunction::GetVoidValue | ( | const char * | name,
|  | const std::type_info & | valueType,
|  | void * | pValue ) const

virtual

Get a named value.

Parameters

  name | the name of the object or value to retrieve
  valueType | reference to a variable that receives the value
  pValue | void pointer to a variable that receives the value

Returns
  true if the value was retrieved, false otherwise

GetVoidValue() retrieves the value of name if it exists.

Note
  GetVoidValue() is an internal function and should be implemented by derived classes. Users should use one of the other functions instead.

See also
  GetValue(), GetValueWithDefault(), GetIntValue(), GetIntValueWithDefault(), GetRequiredParameter() and GetRequiredIntParameter()

Implements NameValuePairs.

## AssignFrom()

void InvertibleRSAFunction::AssignFrom | ( | const NameValuePairs & | source | ) |

virtual

Assign values to this object.

This function can be used to create a public key from a private key.

Implements CryptoMaterial.

## GetPrime1()

const Integer & InvertibleRSAFunction::GetPrime1 | ( |  | ) | const

inline

Definition at line 122 of file rsa.h.

## GetPrime2()

const Integer & InvertibleRSAFunction::GetPrime2 | ( |  | ) | const

inline

Definition at line 123 of file rsa.h.

## GetPrivateExponent()

const Integer & InvertibleRSAFunction::GetPrivateExponent | ( |  | ) | const

inline

Definition at line 124 of file rsa.h.

## GetModPrime1PrivateExponent()

const Integer & InvertibleRSAFunction::GetModPrime1PrivateExponent | ( |  | ) | const

inline

Definition at line 125 of file rsa.h.

## GetModPrime2PrivateExponent()

const Integer & InvertibleRSAFunction::GetModPrime2PrivateExponent | ( |  | ) | const

inline

Definition at line 126 of file rsa.h.

## GetMultiplicativeInverseOfPrime2ModPrime1()

const Integer & InvertibleRSAFunction::GetMultiplicativeInverseOfPrime2ModPrime1 | ( |  | ) | const

inline

Definition at line 127 of file rsa.h.

## SetPrime1()

void InvertibleRSAFunction::SetPrime1 | ( | const Integer & | p | ) |

inline

Definition at line 129 of file rsa.h.

## SetPrime2()

void InvertibleRSAFunction::SetPrime2 | ( | const Integer & | q | ) |

inline

Definition at line 130 of file rsa.h.

## SetPrivateExponent()

void InvertibleRSAFunction::SetPrivateExponent | ( | const Integer & | d | ) |

inline

Definition at line 131 of file rsa.h.

## SetModPrime1PrivateExponent()

void InvertibleRSAFunction::SetModPrime1PrivateExponent | ( | const Integer & | dp | ) |

inline

Definition at line 132 of file rsa.h.

## SetModPrime2PrivateExponent()

void InvertibleRSAFunction::SetModPrime2PrivateExponent | ( | const Integer & | dq | ) |

inline

Definition at line 133 of file rsa.h.

## SetMultiplicativeInverseOfPrime2ModPrime1()

void InvertibleRSAFunction::SetMultiplicativeInverseOfPrime2ModPrime1 | ( | const Integer & | u | ) |

inline

Definition at line 134 of file rsa.h.

The documentation for this class was generated from the following file:

- rsa.h